# A System for detection of difference in word usage between Buddhist and Nonbuddhist Sanskrit

For more details about the system, [see the conference paper](https://aclanthology.org/2021.naacl-main.369/), published in Proceedings of the 2021 Conference of the North American Chapter of the Association for Computational Linguistics.


## Setup ##

Instructions for installation assume the usage of PyPI package manager.<br/>

Install dependencies if needed: pip install -r requirements.txt <br/>
You also need to download 'tokenizers/punkt/english.pickle' using nltk library.

### Prepare the data :<br/> 

The script preprocess_data.py accepts corpus in the original format as an input (the corpus can be found in folder data) and converts it into the .tsv format. To run 
the script on the data, run:<br/>

```
python preprocess_data.py  --data_path data/CorporaJuly2023 --output_path data/sanskrit_buddhist_nonbuddhist_corpus.tsv
```

**Arguments:**<br/>
**--data_path** Path to the folder containing the corpus <br/>
**--output_path** Path of the output .tsv file <br/>

The script build_vocab.py accepts the corpus in the tsv format as an input and returns files needed for embeddings generation. To run 
the script on the example data, run:<br/>

```
python build_vocab.py  --data_path data/sanskrit_buddhist_nonbuddhist_corpus.tsv --output_dir vocab --min_freq 10
```

**Arguments:**<br/>
**--data_path** Path to the tsv file containing the data <br/>
**--output_dir** Path to the folder that will contain generated output vocab and language_model training files <br/>
**--min_freq** Minimum frequency of the word in a specific chunk to be included in the vocabulary <br/>


**Outputs:**<br/>
2.) **vocab.pickle** A pickled vocab class used as input for script get_embeddings_scalable.py <br/>
5.) **vocab_list_of_words.csv** All words in the corpus vocab for which semantic shift will be calculated <br/>


### Extract embeddings:<br/>

Generate corpus chunk specific embeddings (i.e. buddhist or nonbuddhist):<br/>

```
python get_embeddings_scalable.py --vocab_path vocab/vocab.pickle --embeddings_path embeddings/embeddings.pickle --batch_size 16 --max_sequence_length 128 --device cuda
```

**Arguments:**<br/>
**--vocab_path** Paths to vocab pickle file generated by the preprocessing.py script <br/>
**--embeddings_path** Path to output pickle file containing embeddings. <br/>

**Outputs:**<br/>
**1.) output pickle file containing embeddings**


### Conduct clustering and measure semantic shift:<br/>

```
python measure_semantic_shift.py --output_dir output --embeddings_path embeddings/embeddings.pickle --random_state 123 --cluster_size_threshold 5 --metric JSD
```

**Arguments:**<br/>
**--output_dir** Paths to output results folder <br/>
**--embeddings_path** Path to input pickle file containing embeddings <br/>
**--random_state** Random seed <br/>
**--cluster_size_threshold** Remove cluster or merge it with other if it contains less than threshold word usages <br/>
**--metric** Which metric to use for measuring semantic shift, should be JSD or WD <br/>

**Outputs:**<br/>
1.) **word_list_results.csv** a list of all words in the vocab with their semantic change scores <br/>
2.) **corpus_slices.pkl** pickled list of corpus slices used as input for script 'interpretation.py' <br/>
3.) **id2sents.pkl** pickled sentence dictionary used as input for script 'interpretation.py' <br/>
4.) **kmeans_5_labels.pkl** pickled dictionary of kmeans cluster labels for each word usage used as input for script 'interpretation.py' <br/>
5.) **sents.pkl** pickled list of all sentences  used as input for script 'interpretation.py' <br/>


### Extract keywords for each cluster and plot clusters distributions for interpretation:<br/>

```
python interpretation.py  --target_words "dharma" --input_dir output --results_dir results --cluster_size_threshold 5 --max_df 0.8 --num_keywords 15
```

**Arguments:**<br/>
**--target_words** Target words to analyse, separated by comma <br/>
**--input_dir** Folder containing data generated by the script 'measure_semantic_shift.py <br/>
**--results_dir** Path to final results <br/>
**--max_df** Words that appear in more than that percentage of clusters will not be used as keywords <br/>
**--cluster_size_threshold** Clusters smaller than a threshold will be deleted <br/>
**--num_keywords** Number of keywords per cluster <br/>


**Outputs:**<br/>
**1.) An image showing a distribution of word usages for each target word** <br/>
**2.) A tsv document per each target word containing information about sentences in which it appeared and into which cluster was each usage clustered** <br/>

